#include "huc.h"
#include "const.c"
#include "var.c"
#include "text.c"

#define LIFEMAX 500
#define MPMAX 30
#define TITLEPCX "title.pcx"
#define SPRITE "sprite2.pcx"
#define TILES "tiles.pcx"
#define SCREEN "screen.pcx"
#define DEX 40
#define ATK 50
#define DEF 50

/***************************************/
/*             String copy             */
/***************************************/
strcpy(lhs,rhs)
char* lhs;
char* rhs;
{
  while (*rhs)
    *lhs++=*rhs++;
  *lhs=0;

}

/***************************************/
/*        MAIN         PROG            */
/***************************************/

main()
{
char select;

DexP[0]=50;
AtkP[0]=70;
DefP[0]=60;
DexP[1]=70;
AtkP[1]=50;
DefP[1]=40;
strcpy(NamP1,"Willy");
strcpy(NamP2,"Yoko");
strcpy(NamP3,"Sonny");
strcpy(NamP4,"Gramps");
MaxHP[0]=LIFEMAX;
MaxMP[0]=MPMAX;
MaxHP[1]=2*LIFEMAX/3;
MaxMP[1]=3*MPMAX;

while (1)
{
 cls();
 set_font_color(1,2);
 load_default_font();

HPp[0]=MaxHP[0];
HPp[1]=MaxHP[1];
itemnb[0]=5;
itemnb[1]=2;
MPp[0]=MaxMP[0];
MPp[1]=MaxMP[1];
ExpP[0]=10;
ExpP[1]=10;
select=0;

 load_background(titlegfx,titlepal,titlebat,32,28);

 put_string("Start a battle",11,22);
 put_string("Change name",11,20);
 put_string("Begin game",11,18);
 put_char('-',9,18);

 while (!(joytrg(0) & JOY_STRT))
 {
  if ((joytrg(0) & JOY_UP) && (select>0))
    {
     select--;
     put_char(' ',9,20+2*select);
     put_char('-',9,18+2*select);
    }
  if ((joytrg(0) & JOY_DOWN) && (select<2))
    {
     select++;
     put_char(' ',9,16+2*select);
     put_char('-',9,18+2*select);
    }
   vsync(1);
 }

switch (select)
{
  case 2:
    battle(LIFEMAX,ATK,DEF,DEX,0);
    break;

  case 1:
    strcpy(Entry,NamP1);
    enter();
    strcpy(NamP1,Entry);
    strcpy(Entry,NamP2);
    enter();
    strcpy(NamP2,Entry);
    strcpy(Entry,NamP3);
    enter();
    strcpy(NamP3,Entry);
    strcpy(Entry,NamP4);
    enter();
    strcpy(NamP4,Entry);
    break;

  case 0:
    game();
    break;
}

}
}
/*******************************************/
/*              Battle System              */
/*******************************************/
#include "battle.c";
/*******************************************/
/*               Name Change               */
/*******************************************/
enter()
{
 char i,j,k;
 cls();
 border(0,0,32,28);
 border(11,10,8,3);

 put_string("Enter player name",7,4);
 border(6,3,19,3);

 border(2,20,28,6);
 for(i='A';i<'Z'+1;i++)
 {
  put_char(i,3+i-'A',21);
  put_char(i-'A'+'a',3+i-'A',23);
 }

 i=0;
 j=0;
 k=0;
 Entry[6]=0;
 while (!(joytrg(0) & JOY_STRT))
  {
   if ((joytrg(0) & JOY_RGHT) && (i<26)) i++;
    else
      if ((joytrg(0) & JOY_LEFT) && (i>0)) i--;
   if ((joytrg(0) & JOY_B) && (k>0))
      {Entry[k]=0;
      put_char(' ',12+k,13);
      k--;
      put_char('^',12+k,13);}
   if ((joytrg(0) & JOY_A) && (k==5)) Entry[k]=i+'A'+j*('a'-'A');
   if ((joytrg(0) & JOY_A) && (k<5))
      {Entry[k]=i+'A'+j*('a'-'A');
       put_char(' ',12+k,13);
       k++;
       put_char('^',12+k,13);}
   if ((joytrg(0) & JOY_UP) && (j>0)) j--;
    else
      if ((joytrg(0) & JOY_DOWN) && (j<1)) j++;
   put_string("      ",12,11);
   put_string(Entry,12,11);
   blank(3,22,26,1);
   blank(3,24,26,1);
   put_char('^',3+i,22+2*j);
   vsync(1);
  }

 return;
}
/************************************************/
#include "game.c"
/***********************************************/
#include "magic.c"
/***********************************************/
#include "map.c"
/***********************************************/
#include "move.c"
/***********************************************/
/*           Create Border Function            */
/***********************************************/
border(x,y,i,j)
char x,y,i,j;
{
char a;

set_bgpal(0,screenpal);
load_sprites(0X1000,screengfx);
set_font_color(1,2);
load_default_font();

put_raw(0X100,x,y);
put_raw(0X102,x+i-1,y);
put_raw(0X106,x,y+j-1);
put_raw(0X108,x+i-1,y+j-1);
a=1;
while(a<i-1)
 {
  put_raw(0X101,x+a,y);
  put_raw(0X107,x+a,y+j-1);
  a++;
 }
a=1;
while(a<j-1)
 {
  put_raw(0X103,x,y+a);
  put_raw(0X105,x+i-1,y+a);
  a++;
 }
}
/***********************************************/
/*          Fill with blank Function           */
/***********************************************/
blank(x,y,i,j)
char x,y,i,j;
{
char a,b;
a=0;
while(a<i)
 {
  b=0;
  while(b<j)
  {
   put_char(' ',x+a,y+b);
   b++;
  }
  a++;
 }
}
/***********************************************/
#incchr(titlegfx,TITLEPCX,32,28);
#incpal(titlepal,TITLEPCX);
#incbat(titlebat,TITLEPCX,0x1000,32,28);

#incchr(screengfx,SCREEN,3,3);
#incpal(screenpal,SCREEN);

#incchr(tilesgfx,TILES,8,8);
#incpal(tilespal,TILES);

#incspr(sprgfx,SPRITE,2,1);
#incpal(spritepal,SPRITE);

